﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Kooboo.HtmlFunc.Providers;

namespace Kooboo.CMS.SiteConverter.Parser
{
    public interface IParserFactory
    {
        ParserContext Context { get; }

        IParser<ILayout> LayoutParser { get; }

        IParser<IPosition> PositionParser { get; }

        IParser<IHtmlPart> HtmlPartParser { get; }

        IParser<IViewPart> ViewPartParser { get; }

        IParser<IHtmlBlockPart> HtmlBlockPartParser { get; }

        IParser<ILabel> LabelParser { get; }

        IParser<Kooboo.CMS.SiteConverter.Models.FileUrl> FileUrlParser { get; }

        IParser<IPageSetting> PageSettingParser { get; }

        IParser<IMetaTag> MetaParser { get; }

        IParser<IMenu> MenuParser { get; }

        IParser<IList> ListParser { get; }

        IParser<IDetail> DetailParser { get; }
    }
}
