﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Kooboo.HtmlFunc.Function;
using Kooboo.HtmlFunc.Providers;

namespace Kooboo.HtmlFunc.Analysis
{
    public class VisitorContext : IContextual<VisitorContext>
    {
        public VisitorContext()
        {
            this.Result = Provider.Factory.GetProvider<IAnalyseResult>();
            this.Items = new Dictionary<FuncType, object>();
        }

        public string FileName
        {
            get;
            set;
        }

        public bool ThrowException
        {
            get;
            set;
        }

        public IAnalyseResult Result
        {
            get;
            private set;
        }

        public IDictionary<FuncType, object> Items
        {
            get;
            private set;
        }

        #region IContextual<VisitorContext> Members

        public VisitorContext Current
        {
            get { throw new NotImplementedException(); }
        }

        #endregion
    }
}
