﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using HtmlAgilityPack;
using Kooboo.HtmlFunc.Function;
using Kooboo.HtmlFunc.Providers;

namespace Kooboo.HtmlFunc.Analysis.Visitors
{
    public class ListItemVisitor : StartEndVisitor
    {
        public ListItemVisitor(VisitorContext context)
            : base(context, FuncType.ListItem)
        {
        }

        protected override object OnQualified(HtmlCommentNode startNode, HtmlCommentNode endNode)
        {
            var list = (IList)this.Context.Items[FuncType.List];
            list.ItemStartNode = startNode;
            list.ItemEndNode = endNode;

            // ret context mark
            return list;
        }

        protected override FuncType RequireType
        {
            get
            {
                return FuncType.List;
            }
        }

        protected override FuncType ExclusiveType
        {
            get
            {
                return this.FuncType;
            }
        }
    }
}
