﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using HtmlAgilityPack;
using Kooboo.HtmlFunc.Function;
using Kooboo.HtmlFunc.Providers;

namespace Kooboo.HtmlFunc.Analysis.Visitors
{
    public class MenuCurrentClassVisitor : VisitorBase
    {
        public MenuCurrentClassVisitor(VisitorContext context)
            : base(context, FuncType.MenuCurrentClass)
        {
            this.AttributeName = this.Func.StartComment;
        }

        public string AttributeName
        {
            get;
            private set;
        }

        public override void VisitAttribute(HtmlAttribute attribute)
        {
            if (this.ValidateRule() &&
                this.AttributeName.IgnoreCaseEquals(attribute.Name))
            {
                var menu = this.Context.Items[FuncType.Menu] as IMenu;
                menu.CurrentClassAttribute = attribute;
            }
        }

        protected override FuncType RequireType
        {
            get
            {
                return FuncType.MenuItem;
            }
        }
    }
}
