﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using HtmlAgilityPack;
using Kooboo.HtmlFunc.Function;
using Kooboo.HtmlFunc.Providers;

namespace Kooboo.HtmlFunc.Analysis.Visitors
{
    public class TitleTagVisitor : VisitorBase
    {
        public TitleTagVisitor(VisitorContext context)
            : base(context)
        {
        }

        private bool setted = false;
        public override void VisitNode(HtmlNode node)
        {
            if (setted)
            {
                return;
            }

            if (node.Is("TITLE"))
            {
                if (node.ParentNode.Is("HEAD"))
                {
                    setted = true;

                    var titleTag = Provider.Factory.GetProvider<ITitleTag>();
                    titleTag.Node = node;
                    this.Context.Result.TitleTag = titleTag;
                }
            }
        }
    }
}
