﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using HtmlAgilityPack;

namespace Kooboo.HtmlFunc.Exceptions
{
    public class ParameterEmptyException : FuncCommentNodeException
    {
        public ParameterEmptyException(string fileName, HtmlCommentNode node, string parameterKey)
            : base(fileName, node)
        {
            this.ParameterKey = parameterKey;
        }

        public string ParameterKey
        {
            get;
            private set;
        }

        public override string ExceptionDescription
        {
            get
            {
                return string.Format("Can not find the parameter key \"{0}\" in {1}.", this.ParameterKey, this.ExceptionNode.Comment);
            }
        }
    }
}
