﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using HtmlAgilityPack;
using Kooboo.HtmlFunc.Providers;

namespace Kooboo.HtmlFunc.Models
{
    public class List : IList
    {
        public List()
        {
            this.LinkItems = new List<ILinkItem>();
            this.DataItems = new List<IDataItem>();
        }

        #region IList Members

        public string FolderName
        {
            get;
            set;
        }

        public int? PageSize
        {
            get;
            set;
        }

        public int? TakeTop
        {
            get;
            set;
        }

        public string OrderBy
        {
            get;
            set;
        }

        public string OrderByDescending
        {
            get;
            set;
        }

        public HtmlAttribute EditableAttribute
        {
            get;
            set;
        }

        public IList<ILinkItem> LinkItems
        {
            get;
            set;
        }

        public IList<IDataItem> DataItems
        {
            get;
            set;
        }

        #endregion

        #region IViewPart Members

        public string ViewName
        {
            get;
            set;
        }

        #endregion

        #region IPart Members

        public int? Order
        {
            get;
            set;
        }

        public IPosition OwnerPosition
        {
            get;
            set;
        }

        #endregion

        #region IEnumerable Members

        public HtmlNode ItemStartNode
        {
            get;
            set;
        }

        public HtmlNode ItemEndNode
        {
            get;
            set;
        }

        #endregion

        #region IFuncMarker Members

        public HtmlNode StartNode
        {
            get;
            set;
        }

        public HtmlNode EndNode
        {
            get;
            set;
        }

        #endregion
    }
}
